function [scoresTr,scoresTe,t] = doWvRN_fast( Xtr,Ytr,Xte,topnodesfunc,R_pos)
%Y should have labels 1 and 0.


if(nargin == 4 || isempty(R_pos))
    Nr_pos = length(find(Ytr == 1));
    R_pos = Nr_pos/length(Ytr);
end

start=tic;
if isnumeric(topnodesfunc)
    weights=topnodesfunc;
else
    tfunc=str2func(char(topnodesfunc));
    weights=tfunc(Xtr,Ytr);
end

Ns=Ytr'*Xtr;
Ns=times(Ns,weights);
Z=sum(Xtr,1);
Z=times(Z,weights);
% scoresTr=rdivide((Xtr* Ns'),(Xtr*Z'+eps));
% scoresTe=rdivide((Xte* Ns'),(Xte*Z'+eps));
scoresTr=rdivide((Xtr* Ns'),(Xtr*Z'));
scoresTe=rdivide((Xte* Ns'),(Xte*Z'));
[x,~,~]=find(sum(Xtr,2)==0);
pro=sum(Ytr(x))/numel(x);
% pro=sum(Ytr)/numel(Ytr);
scoresTr(x)=pro;
[x,~,~]=find(sum(Xte,2)==0);
scoresTe(x)=pro;

%there might still be test instances that show active features, but none
%match with active training set features (so these are not connected to any
%training nodes)
x = find(isnan(scoresTe));
scoresTe(x) = R_pos;
t=toc(start);
%[~,~,~,auc]=perfcurve(Yte,scoresTe,1)

end


