function [projection ] = sum_shared_nodes_NEW(bigraph,weights,Block_Size_X,Block_Size_Y)
%Improved version of sum_shared_nodes

%create a weight reference matrix
[i,j,~] = find(bigraph);
v_weight = weights(j);
tmp = sparse(i,j,v_weight,size(bigraph,1),size(bigraph,2));
%by multiplying the bigraph with the transposed weighted version of itself
%we get the projection
tmp=tmp'; 
projection = Matrix_Multiplication_Blocks(bigraph,tmp,Block_Size_X,Block_Size_Y);


end

