function beta = Beta(Y,h,c)
%The beta function used in AdaCost
%Input
    %Y: true labels (on X)
    %h: result of weak hypothesis (on X)
    %c: misclassification costs (on X)
beta = -0.5*sign(Y.*h).*c + 0.5;
end

