function [nn,sim ] = nearest_neighbours_temp(X,Y,k,sim_measure)

%tic;
a = X*Y';
nr_ones_X = full(sum(X,2));
nr_ones_Y = full(sum(Y,2));


switch sim_measure
    case 'Jaccard'
        nr_ones_X_rep = repmat(nr_ones_X,1,size(Y,1));
        nr_ones_Y_rep =  repmat(nr_ones_Y',size(X,1),1);
        similarity = a./(nr_ones_X_rep+nr_ones_Y_rep - a);
        similarity(similarity == 1) = 0;%this means similarity one, so should be removed
    case 'Cosine'
        similarity = a./sqrt(nr_ones_X*nr_ones_Y');
        similarity(similarity == 1) = 0;%this means similarity one, so should be removed
end
%toc

%tic;
[sim_sort,I] = sort(similarity,2,'descend');
%toc

nn = I(:,1:k);
sim = full(sim_sort(:,1:k)); 

end

