function [ projection ] = sum_shared_nodes( bigraph, weights, first, last,cutoff)

weights=sparse(weights);
%create a weight reference matrix
tmp=bsxfun(@times, bigraph, weights); 
%by multiplying the bigraph with the transposed weighted version of itself
%we get the projection
tmp=sparse(tmp);
tmp=tmp'; 
projection=bigraph(first:last,:)*tmp(:,1:cutoff);

end
 
